/* main.c - widget */

#ifndef lint
static char *rcsid = "$Header: /Pluto/Pluto2/src/local/X500/sd/RCS/main.c,v 1.6 90/04/26 10:36:27 emsrdsm Exp Locker: emsrdsm $";
#endif

/*
 * $Header: /Pluto/Pluto2/src/local/X500/sd/RCS/main.c,v 1.6 90/04/26 10:36:27 emsrdsm Exp Locker: emsrdsm $
 */

/*
 * $Log:	main.c,v $
 * Revision 1.6  90/04/26  10:36:27  emsrdsm
 * *** empty log message ***
 * 
 * Revision 1.5  90/04/25  15:07:40  emsrdsm
 * i) lint'ed
 * 
 * Revision 1.4  90/04/20  17:57:54  emsrdsm
 * i) no more freeing
 * 
 * Revision 1.3  90/04/18  18:27:58  emsrdsm
 * fixed i) does not move to leaves
 *       ii) added default mechanism described using "typeDefaults" file.
 * 	 iii) added 'sorting' to attribute display
 * 
 * Revision 1.2  90/03/15  16:32:06  emsrdsm
 * fixes i) Prints messages correctly on exit.
 *      ii) Added rfc822 to greybook mailbox conversion
 *     iii) Removed bug that caused crash if 'local_dit' undefined
 * 
 * Revision 1.1  90/03/09  17:40:30  emsrdsm
 * Initial revision
 * 
 * Revision 1.1  90/03/09  13:36:54  emsrdsm
 * Initial revision
 * 
 */

#include <sys/types.h>
#include <stdio.h>
#include <signal.h>
#include <curses.h>
#include <varargs.h>

#include "widget.h"
#include "quipu/util.h"

char    currentpath[1024];

extern  int     wprint(),new_service();
extern  char    goto_path[], namestr[], passwd[];
extern  char   *myname;
extern  WINDOW  *Text;
extern  WIDGET  mainwdgts[];
extern  WIDGET  cnnctwdgts[];
extern int      print_parse_errors;

main(argc, argv)
int     argc;
char    *argv[];
{
    print_parse_errors = FALSE;
    quipu_syntaxes();
    dsap_init (&argc,&argv);

    initwidgets();                      /* Call the screen/curses/widget*/
    setsignals();

    user_tailor(); 
    main_bind();
    cnnct_bind();
    help_init();
    interact();
    quit("\n", -1);
}


setsignals()
{
  int     i;

  for (i=0; i<18; i++)
    (void) signal(i, SIG_DFL);
}

eprint(str)
char    *str;
{
  tprint(str);
}

sd_quit()
{
  quit("\n", 0);
}

/* This tidies up the terminal, writes the current history list and finishes */
quit(error, sig)
char    *error;
int     sig;
{
  endwidgets();
  (void) ds_unbind();
  hide_picture();
  (void) printf(error);
  exit(sig);
}

void int_quit(sig)
int     sig;
{
  quit(sig);
}


void    advise (va_alist)
va_dcl
{
  int     code;
  va_list ap;
  extern LLog * log_dsap;
  
  va_start (ap);
  
  code = va_arg (ap, int);
  
  (void) _ll_log (log_dsap, code, ap);
  
  va_end (ap);
}
